package com.hai.dao;

import com.hai.entity.TbRechargePayOrderExample.Criteria;
import com.hai.entity.TbRechargePayOrderExample.Criterion;
import com.hai.entity.TbRechargePayOrderExample;
import com.hai.entity.TbRechargePayOrderWithBLOBs;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class TbRechargePayOrderSqlProvider {

    public String countByExample(TbRechargePayOrderExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("tb_recharge_pay_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(TbRechargePayOrderExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("tb_recharge_pay_order");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(TbRechargePayOrderWithBLOBs record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("tb_recharge_pay_order");
        
        if (record.getValidstartdate() != null) {
            sql.VALUES("validStartDate", "#{validstartdate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidenddate() != null) {
            sql.VALUES("validEndDate", "#{validenddate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatetime() != null) {
            sql.VALUES("createtime", "#{createtime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getModifytime() != null) {
            sql.VALUES("modifytime", "#{modifytime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPrebalance() != null) {
            sql.VALUES("preBalance", "#{prebalance,jdbcType=DECIMAL}");
        }
        
        if (record.getPostbalance() != null) {
            sql.VALUES("postBalance", "#{postbalance,jdbcType=DECIMAL}");
        }
        
        if (record.getRechargeid() != null) {
            sql.VALUES("rechargeId", "#{rechargeid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getPhone() != null) {
            sql.VALUES("phone", "#{phone,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCouno() != null) {
            sql.VALUES("couNo", "#{couno,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getDistributorid() != null) {
            sql.VALUES("distributorId", "#{distributorid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getDistcoucount() != null) {
            sql.VALUES("distCouCount", "#{distcoucount,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCoutypecode() != null) {
            sql.VALUES("couTypeCode", "#{coutypecode,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCreateuser() != null) {
            sql.VALUES("`createuser`", "#{createuser,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getModifyuser() != null) {
            sql.VALUES("modifyuser", "#{modifyuser,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getBillversion() != null) {
            sql.VALUES("billVersion", "#{billversion,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getReconversion() != null) {
            sql.VALUES("reconVersion", "#{reconversion,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getPromoterid() != null) {
            sql.VALUES("promoterId", "#{promoterid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getAccessType() != null) {
            sql.VALUES("access_type", "#{accessType,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getStaticcheckcode() != null) {
            sql.VALUES("staticCheckCode", "#{staticcheckcode,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getUseShop() != null) {
            sql.VALUES("use_shop", "#{useShop,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getUseTime() != null) {
            sql.VALUES("use_time", "#{useTime,jdbcType=LONGVARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExampleWithBLOBs(TbRechargePayOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("validStartDate");
        } else {
            sql.SELECT("validStartDate");
        }
        sql.SELECT("validEndDate");
        sql.SELECT("createtime");
        sql.SELECT("modifytime");
        sql.SELECT("preBalance");
        sql.SELECT("postBalance");
        sql.SELECT("id");
        sql.SELECT("rechargeId");
        sql.SELECT("phone");
        sql.SELECT("couNo");
        sql.SELECT("`status`");
        sql.SELECT("distributorId");
        sql.SELECT("distCouCount");
        sql.SELECT("couTypeCode");
        sql.SELECT("`createuser`");
        sql.SELECT("modifyuser");
        sql.SELECT("billVersion");
        sql.SELECT("reconVersion");
        sql.SELECT("promoterId");
        sql.SELECT("access_type");
        sql.SELECT("staticCheckCode");
        sql.SELECT("use_shop");
        sql.SELECT("use_time");
        sql.FROM("tb_recharge_pay_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String selectByExample(TbRechargePayOrderExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("validStartDate");
        } else {
            sql.SELECT("validStartDate");
        }
        sql.SELECT("validEndDate");
        sql.SELECT("createtime");
        sql.SELECT("modifytime");
        sql.SELECT("preBalance");
        sql.SELECT("postBalance");
        sql.FROM("tb_recharge_pay_order");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        TbRechargePayOrderWithBLOBs record = (TbRechargePayOrderWithBLOBs) parameter.get("record");
        TbRechargePayOrderExample example = (TbRechargePayOrderExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("tb_recharge_pay_order");
        
        if (record.getValidstartdate() != null) {
            sql.SET("validStartDate = #{record.validstartdate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getValidenddate() != null) {
            sql.SET("validEndDate = #{record.validenddate,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreatetime() != null) {
            sql.SET("createtime = #{record.createtime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getModifytime() != null) {
            sql.SET("modifytime = #{record.modifytime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getPrebalance() != null) {
            sql.SET("preBalance = #{record.prebalance,jdbcType=DECIMAL}");
        }
        
        if (record.getPostbalance() != null) {
            sql.SET("postBalance = #{record.postbalance,jdbcType=DECIMAL}");
        }
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getRechargeid() != null) {
            sql.SET("rechargeId = #{record.rechargeid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getPhone() != null) {
            sql.SET("phone = #{record.phone,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCouno() != null) {
            sql.SET("couNo = #{record.couno,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getDistributorid() != null) {
            sql.SET("distributorId = #{record.distributorid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getDistcoucount() != null) {
            sql.SET("distCouCount = #{record.distcoucount,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCoutypecode() != null) {
            sql.SET("couTypeCode = #{record.coutypecode,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getCreateuser() != null) {
            sql.SET("`createuser` = #{record.createuser,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getModifyuser() != null) {
            sql.SET("modifyuser = #{record.modifyuser,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getBillversion() != null) {
            sql.SET("billVersion = #{record.billversion,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getReconversion() != null) {
            sql.SET("reconVersion = #{record.reconversion,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getPromoterid() != null) {
            sql.SET("promoterId = #{record.promoterid,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getAccessType() != null) {
            sql.SET("access_type = #{record.accessType,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getStaticcheckcode() != null) {
            sql.SET("staticCheckCode = #{record.staticcheckcode,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getUseShop() != null) {
            sql.SET("use_shop = #{record.useShop,jdbcType=LONGVARCHAR}");
        }
        
        if (record.getUseTime() != null) {
            sql.SET("use_time = #{record.useTime,jdbcType=LONGVARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExampleWithBLOBs(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("tb_recharge_pay_order");
        
        sql.SET("validStartDate = #{record.validstartdate,jdbcType=TIMESTAMP}");
        sql.SET("validEndDate = #{record.validenddate,jdbcType=TIMESTAMP}");
        sql.SET("createtime = #{record.createtime,jdbcType=TIMESTAMP}");
        sql.SET("modifytime = #{record.modifytime,jdbcType=TIMESTAMP}");
        sql.SET("preBalance = #{record.prebalance,jdbcType=DECIMAL}");
        sql.SET("postBalance = #{record.postbalance,jdbcType=DECIMAL}");
        sql.SET("id = #{record.id,jdbcType=LONGVARCHAR}");
        sql.SET("rechargeId = #{record.rechargeid,jdbcType=LONGVARCHAR}");
        sql.SET("phone = #{record.phone,jdbcType=LONGVARCHAR}");
        sql.SET("couNo = #{record.couno,jdbcType=LONGVARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=LONGVARCHAR}");
        sql.SET("distributorId = #{record.distributorid,jdbcType=LONGVARCHAR}");
        sql.SET("distCouCount = #{record.distcoucount,jdbcType=LONGVARCHAR}");
        sql.SET("couTypeCode = #{record.coutypecode,jdbcType=LONGVARCHAR}");
        sql.SET("`createuser` = #{record.createuser,jdbcType=LONGVARCHAR}");
        sql.SET("modifyuser = #{record.modifyuser,jdbcType=LONGVARCHAR}");
        sql.SET("billVersion = #{record.billversion,jdbcType=LONGVARCHAR}");
        sql.SET("reconVersion = #{record.reconversion,jdbcType=LONGVARCHAR}");
        sql.SET("promoterId = #{record.promoterid,jdbcType=LONGVARCHAR}");
        sql.SET("access_type = #{record.accessType,jdbcType=LONGVARCHAR}");
        sql.SET("staticCheckCode = #{record.staticcheckcode,jdbcType=LONGVARCHAR}");
        sql.SET("use_shop = #{record.useShop,jdbcType=LONGVARCHAR}");
        sql.SET("use_time = #{record.useTime,jdbcType=LONGVARCHAR}");
        
        TbRechargePayOrderExample example = (TbRechargePayOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("tb_recharge_pay_order");
        
        sql.SET("validStartDate = #{record.validstartdate,jdbcType=TIMESTAMP}");
        sql.SET("validEndDate = #{record.validenddate,jdbcType=TIMESTAMP}");
        sql.SET("createtime = #{record.createtime,jdbcType=TIMESTAMP}");
        sql.SET("modifytime = #{record.modifytime,jdbcType=TIMESTAMP}");
        sql.SET("preBalance = #{record.prebalance,jdbcType=DECIMAL}");
        sql.SET("postBalance = #{record.postbalance,jdbcType=DECIMAL}");
        
        TbRechargePayOrderExample example = (TbRechargePayOrderExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    protected void applyWhere(SQL sql, TbRechargePayOrderExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}